Please use the Apache issue tracking system for new NetBeans issues (https://issues.apache.org/jira/projects/NETBEANS0/issues) !!
Bug 146617 - 12s wasted while expanding 163 files
12s wasted while expanding 163 files
Status: VERIFIED FIXED
Product: versioncontrol
Classification: Unclassified
Component: Mercurial
6.x
All All
: P2 (vote)
: 6.x
Assigned To: issues@versioncontrol
issues@versioncontrol
: PERFORMANCE
Depends on:
Blocks: 144131
  Show dependency treegraph
 
Reported: 2008-09-09 10:20 UTC by Jaroslav Tulach
Modified: 2008-11-24 08:26 UTC (History)
1 user (show)

See Also:
Issue Type: DEFECT
:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Jaroslav Tulach 2008-09-09 10:20:49 UTC
While investigating issue 144131, adding numerous logging lines, running profiler in various possible and impossible 
configurations, Nigel managed to capture profiling snapshot:

http://www.netbeans.org/nonav/issues/showattachment.cgi/69382/nb_mk2.nps

It shows that 12s is wasted in visibility query. Quite surprisingly it is Subversion visibility query which then 
delegates to mercurial(!) and spends 12s there. Please, speed up by ~12s for release 6.5 please and for new revision 
consider rewriting the system to follow some logical rules when delegating between various version control system.
Comment 1 Tomas Stupka 2008-09-09 11:54:45 UTC
see a couple of issues here:
1.) slow hg.getTopMostManagedAncesor
2.) cross delegation between vcs in VQ - should be managed the same way as the CQ by the versioning manager - new isssue
#146634

Comment 2 Tomas Stupka 2008-09-09 14:21:17 UTC
too much unnecessary File.canWrite() calls in Mercurial.getTMP. 

i've added some caching, should significantly reduce their amount.
changeset:   100804:b6de3e9e3e4b

Nigel, if you aren't already too tired from all the profiler sessions, it would be great if you could take a snapshot
one more time. The same as you did for 144131. 

you either have to wait for tomorrows build or i could send you the patched module.

thanks a lot
Comment 3 Quality Engineering 2008-09-10 05:47:55 UTC
Integrated into 'main-golden', will be available in build *200809100201* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main/rev/b6de3e9e3e4b
User: Tomas Stupka <tstupka@netbeans.org>
Log: #146617 - 12s wasted while expanding 163 files
Comment 4 Tomas Stupka 2008-09-10 11:20:02 UTC
created a simple scenario to measure the amount of canWrite calls in hg.getTMP. The fix reduced them to 7% compared to
the old implementation, so i consider this fixed for now. 

Lets verify or reopen the issue based on the snapshot from Nigel
Comment 5 nleck 2008-09-12 23:47:51 UTC
I've downloaded the latest build it is faster, I hope we can still go a little faster but it's much improved thx. 
Comment 6 matusdekanek 2008-11-24 08:26:44 UTC
performace seems to be fine.
verifying


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2014, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo